#include <signal.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <unistd.h>

#include <libps2000/ps2000.h>

bool stop = false;

void capture_stop(int signal) {
  (void)signal;
  stop = true;
}

static const uint32_t buffersize = 10000;

void get_overview_buffers(int16_t** overviewBuffers, int16_t overflow, uint32_t triggeredAt, int16_t triggered, int16_t auto_stop, uint32_t nValues) {
  (void)overflow;
  (void)triggeredAt;
  (void)triggered;
  (void)auto_stop;

  fprintf(stderr, "nValues: %u\n", nValues);

  static float floatbuff[10000]; // TODO variable
  for (unsigned i = 0; i < nValues; i++) {
    floatbuff[i] = overviewBuffers[0][i];
    floatbuff[i] /= 32768; // TODO limit.h
  }
  fwrite(floatbuff, sizeof(float), nValues, stdout);
}

int main(int argc, char** argv) {
  (void)argc;
  (void)argv;

  int16_t unit = ps2000_open_unit();

  if (ps2000_set_channel(unit, PS2000_CHANNEL_A, true, false, PS2000_10V) == 0) {
    fprintf(stderr, "set_channel failed!\n");
    ps2000_close_unit(unit);
    return 1;
  }

  if (ps2000_set_trigger(unit, PS2000_NONE, 0, 0, 0, 0) == 0) {
    fprintf(stderr, "set_trigger failed!\n");
    ps2000_close_unit(unit);
    return 1;
  }

  if (ps2000_run_streaming_ns(unit, 1000, PS2000_NS, buffersize, false, 1, 50000) == 0) {
    fprintf(stderr, "run_streaming_ns failed!\n");
    ps2000_close_unit(unit);
    return 1;
  }

  signal(SIGINT, &capture_stop);

  while (!stop) {
    if (ps2000_get_streaming_last_values(unit, &get_overview_buffers) == 0) {
      // fprintf(stderr, "callback won't be called!\n");
    }
    /*
        int16_t overrun = 0;
        if (ps2000_overview_buffer_status(unit, &overrun) != 0) {
          fprintf(stderr, "failed to check overrun!\n");
        } else if (overrun) {
          fprintf(stderr, "overrun!\n");
        }

        // usleep(0);
     */
  }

  ps2000_stop(unit);
  ps2000_close_unit(unit);

  return 0;
}